%define        majver %(echo %version | cut -d. -f 1-2)
%if "%?with_apiver" == ""
%define        apiver 4.0
%define        libname libwebkit2gtk
%else
%define        apiver %with_apiver
%if "%?with_apiver" == "4.1"
%define        libname libwebkit2gtk-%{with_apiver}
%else
%define        libname libwebkitgtk-%{with_apiver}
%endif
%endif

Name:          webkitgtk
Version:       2.42.5
Release:       1mamba
Summary:       Port of WebKit embeddable web component to GTK+
Group:         System/Libraries
Vendor:        openmamba
Distribution:  openmamba
Packager:      Silvan Calarco <silvan.calarco@mambasoft.it>
URL:           https://www.webkitgtk.org/
Source0:       http://www.webkitgtk.org/releases/webkitgtk-%{version}.tar.xz
Patch2:        webkitgtk-2.30.2-x86-arm-jit-build-workaround.patch
Patch3:        webkitgtk-2.42.2-libxml2-2.12.1.patch
Patch4:        webkitgtk-2.42.5-x86-build-fix.patch
License:       BSD, LGPL
## AUTOBUILDREQ-BEGIN
BuildRequires: glibc-devel
BuildRequires: gst-plugins-bad-devel
BuildRequires: libX11-devel
BuildRequires: libXcomposite-devel
BuildRequires: libXdamage-devel
BuildRequires: libXrender-devel
BuildRequires: libXt-devel
BuildRequires: libat-spi2-core-devel
BuildRequires: libatomic-devel
BuildRequires: libavif-devel
BuildRequires: libcairo-devel
BuildRequires: libdrm-devel
BuildRequires: libenchant-devel
BuildRequires: libepoxy-devel
BuildRequires: libfontconfig-devel
BuildRequires: libfreetype-devel
BuildRequires: libgcc
BuildRequires: libgcrypt-devel
BuildRequires: libgdk-pixbuf-devel
BuildRequires: libglib-devel
BuildRequires: libgpg-error-devel
BuildRequires: libgst-plugins-base-devel
BuildRequires: libgstreamer-devel
BuildRequires: libgtk3-devel
BuildRequires: libharfbuzz-devel
BuildRequires: libhyphen-devel
BuildRequires: libicu-devel
BuildRequires: libjpeg-devel
BuildRequires: libjxl-devel
BuildRequires: liblcms2-devel
BuildRequires: libmanette-devel
BuildRequires: libmesa-devel
BuildRequires: libopenjpeg-devel
BuildRequires: libpango-devel
BuildRequires: libpng-devel
BuildRequires: libseccomp-devel
BuildRequires: libsecret-devel
BuildRequires: libsoup-devel
BuildRequires: libsqlite-devel
BuildRequires: libstdc++6-devel
BuildRequires: libsystemd-devel
BuildRequires: libtasn1-devel
BuildRequires: libwayland-devel
BuildRequires: libwayland-egl-devel
BuildRequires: libwebp-devel
BuildRequires: libwoff2-devel
BuildRequires: libwpe-devel
BuildRequires: libwpebackend-fdo-devel
BuildRequires: libxml2-devel
BuildRequires: libxslt-devel
BuildRequires: libz-devel
## AUTOBUILDREQ-END
BuildRequires: bison
BuildRequires: bubblewrap
BuildRequires: flex
BuildRequires: GConf-devel
BuildRequires: geoclue-devel
BuildRequires: gobject-introspection-devel
BuildRequires: gperf
BuildRequires: icu
BuildRequires: libtool
BuildRequires: libnpth-devel
BuildRequires: perl
BuildRequires: unifdef
BuildRequires: xdg-dbus-proxy

%description
WebKit/GTK+ is the new GTK+ port of the WebKit, an open-source web content engine that powers numerous applications such as web browsers, email clients, feed readers, web and text editors, and a whole lot more.

%package -n %{libname}
Summary:       Port of WebKit embeddable web component to GTK+
Group:         System/Libraries
%if "%?with_apiver" == ""
Provides:      %{name}-jsc
Obsoletes:     %{name}-jsc < 2.32.0
%endif

%description -n %{libname}
WebKit/GTK+ is the new GTK+ port of the WebKit, an open-source web content engine that powers numerous applications such as web browsers, email clients, feed readers, web and text editors, and a whole lot more.

%package -n %{libname}-devel
Group:         Development/Libraries
Summary:       Static libraries and headers for %{libname}
Requires:      %{libname} = %{?epoch:%epoch:}%{version}-%{release}

%description -n %{libname}-devel
WebKit/GTK+ is the new GTK+ port of the WebKit, an open-source web content engine that powers numerous applications such as web browsers, email clients, feed readers, web and text editors, and a whole lot more.
This package contains libraries and header files needed for development.

#%package jsc
#Group:         Applications/Networking
#Summary:       JavaScriptCore shell for WebKit GTK+
#Requires:      %{libname} = %{?epoch:%epoch:}%{version}-%{release}
#
#%description jsc
#WebKit/GTK+ is the new GTK+ port of the WebKit, an open-source web content engine that powers numerous applications such as web browsers, email clients, feed readers, web and text editors, and a whole lot more.
#This package contains WebKit's JavaScript engine. It allows you to interact with the JavaScript engine directly.

%package webinspector
Group:         Applications/Networking
Summary:       Data files for WebKit GTK+'s Web Inspector
Obsoletes:     Webkit < 2.32.0

%description webinspector
WebKit/GTK+ is the new GTK+ port of the WebKit, an open-source web content engine that powers numerous applications such as web browsers, email clients, feed readers, web and text editors, and a whole lot more.
This package contains the data files necessary for Web Inspector to work.

%package -n %{libname}-doc
Group:         Documentation
Summary:       Documentation for %{name}

%description -n %{libname}-doc
WebKit/GTK+ is the new GTK+ port of the WebKit, an open-source web content engine that powers numerous applications such as web browsers, email clients, feed readers, web and text editors, and a whole lot more.
This package contains the documentation for %{name},

%debug_package

# Don't clean build at the end
%global __spec_rmbuild_cmd /bin/true

%prep
%setup -q
#-D -T
#:<< _EOF
%ifarch arm %{ix86}
%patch 2 -p1
%patch 4 -p1
%endif
%ifarch arm
#sed -i "s|ARM64|ARMv7|" Source/JavaScriptCore/CMakeLists.txt
sed -i "s|WTF_CPU_ARM64|WTF_CPU_ARM|" CMakeLists.txt
%endif
#%patch 3 -p1

%build
#:<< _EOF
%ifnarch x86_64
# To workaround ar 4GB file limit see also:
# https://build.opensuse.org/package/view_file/openSUSE:Factory/webkit2gtk3/webkit2gtk3.spec
EXTRA_CFLAGS="-g0 -Wl,--no-keep-memory -Wl,--no-map-whole-files"
EXTRA_CXXFLAGS="-g0 -Wl,--no-keep-memory -Wl,--no-map-whole-files"
%else
# Produce minimal debug info: 4.3 GB of debug data makes the
# build too slow and is too much to package for debuginfod
EXTRA_CFLAGS="-g1"
EXTRA_CXXFLAGS="-g1"
%endif

%cmake -d build \
\
   -DPORT=GTK \
   -DCMAKE_BUILD_TYPE=Release \
   -DCMAKE_INSTALL_LIBEXECDIR=%{_libexecdir} \
   -DCMAKE_INSTALL_FULL_LIBEXECDIR=%{_libexecdir} \
   -DCMAKE_C_FLAGS="$EXTRA_CFLAGS" \
   -DCMAKE_CXX_FLAGS="$EXTRA_CXXFLAGS" \
   -DCMAKE_C_FLAGS_RELWITHDEBINFO="-O2 -g1" \
   -DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-O2 -g1" \
%ifnarch x86_64
   -DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed -Wl,-z,now -pthread" \
   -DCMAKE_MODULE_LINKER_FLAGS="-Wl,--as-needed -Wl,-z,now -pthread" \
   -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed -Wl,-z,now -pthread" \
%endif
%ifarch arm
   -DATOMICS_REQUIRE_LIBATOMIC=ON \
   -DENABLE_WEBGL=OFF \
   -DENABLE_GTKDOC=OFF \
   -DENABLE_SPELLCHECK=0 \
%else
   -DENABLE_GTKDOC=ON \
%endif
%if "%?with_apiver" == ""
   -DUSE_SOUP2=ON \
%endif
%if "%?with_apiver" == "4.1"
   -DUSE_SOUP2=OFF \
%endif
%if "%?with_apiver" == "5.0"
   -DUSE_GTK4=ON \
%endif
%if "%?with_apiver" == "6.0"
   -DUSE_GTK4=ON \
   -DUSE_AVIF=ON \
%endif
   -DENABLE_MINIBROWSER=ON

#%ifnarch x86_64
#   -DCMAKE_C_FLAGS="$EXTRA_CFLAGS" \
#   -DCMAKE_CXX_FLAGS="$EXTRA_CXXFLAGS" \
#   -DCMAKE_C_FLAGS_RELWITHDEBINFO="-O2 -g1" \
#   -DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-O2 -g1" \
#%else
#   -DCMAKE_C_FLAGS_RELWITHDEBINFO="-O2 -g1" \
#   -DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-O2 -g1" \
#%endif
#   -DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed -Wl,-z,now -pthread" \
#   -DCMAKE_MODULE_LINKER_FLAGS="-Wl,--as-needed -Wl,-z,now -pthread" \
#   -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed -Wl,-z,now -pthread" \

#   -DENABLE_JIT=OFF \

# Note: seen on arm ,2.30.4: in case of failure due to missing JavaScriptCore-4.gir:
# make JavaScriptCore-4-gir

%make -j2

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"
%makeinstall -C build

%if "%?with_apiver" != ""
rm -f %{buildroot}%{_bindir}/WebKitWebDriver
%endif
%find_lang %{name} --all-name

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%post -n %{libname}
/sbin/ldconfig
%{_bindir}/glib-compile-schemas %{_datadir}/glib-2.0/schemas
:

%postun -n %{libname}
/sbin/ldconfig
%{_bindir}/glib-compile-schemas %{_datadir}/glib-2.0/schemas
:

%files -n %{libname} -f %{name}.lang
%defattr(-,root,root)
%{_libdir}/libwebkit*-%{apiver}.so.*
%{_libdir}/libjavascriptcoregtk-%{apiver}.so.*
%{_libdir}/girepository-1.0/JavaScriptCore-%{apiver}.typelib
%{_libdir}/girepository-1.0/WebKit*-%{apiver}.typelib
%{_libdir}/webkit*-%{apiver}/injected-bundle/libwebkit*gtkinjectedbundle.so
%dir %{_libexecdir}/webkit*-%{apiver}
%{_libexecdir}/webkit*-%{apiver}/*

%files -n %{libname}-devel
%defattr(-,root,root)
%if "%?with_apiver" == ""
%{_bindir}/WebKitWebDriver
%endif
%dir %{_includedir}/webkitgtk-%{apiver}
%{_includedir}/webkitgtk-%{apiver}/*
%{_libdir}/libjavascriptcoregtk-%{apiver}.so
%{_libdir}/libwebkit*-%{apiver}.so
%{_datadir}/gir-1.0/JavaScriptCore-%{apiver}.gir
%{_datadir}/gir-1.0/WebKit*-%{apiver}.gir
%{_libdir}/pkgconfig/webkit*-%{apiver}.pc
%{_libdir}/pkgconfig/javascriptcoregtk-%{apiver}.pc

%files -n %{libname}-doc
%defattr(-,root,root)
%dir %{_datadir}/gtk-doc/html/javascriptcoregtk-%{apiver}
%{_datadir}/gtk-doc/html/javascriptcoregtk-%{apiver}/*
%dir %{_datadir}/gtk-doc/html/webkit*-%{apiver}
%{_datadir}/gtk-doc/html/webkit*-%{apiver}/*

%changelog
* Fri Feb 09 2024 Automatic Build System <autodist@openmamba.org> 2.42.5-1mamba
- automatic version update by autodist

* Sun Jan 07 2024 Automatic Build System <autodist@openmamba.org> 2.42.4-1mamba
- automatic version update by autodist

* Sat Nov 25 2023 Automatic Build System <autodist@mambasoft.it> 2.42.2-1mamba
- automatic version update by autodist

* Fri Feb 17 2023 Automatic Build System <autodist@mambasoft.it> 2.38.5-1mamba
- automatic version update by autodist

* Sat Feb 04 2023 Automatic Build System <autodist@mambasoft.it> 2.38.4-1mamba
- automatic version update by autodist

* Fri Dec 23 2022 Automatic Build System <autodist@mambasoft.it> 2.38.3-1mamba
- automatic version update by autodist

* Mon Nov 21 2022 Automatic Build System <autodist@mambasoft.it> 2.38.2-1mamba
- automatic version update by autodist

* Mon Oct 31 2022 Automatic Build System <autodist@mambasoft.it> 2.38.1-1mamba
- automatic version update by autodist

* Fri Aug 26 2022 Automatic Build System <autodist@mambasoft.it> 2.36.7-1mamba
- automatic version update by autodist

* Tue Aug 09 2022 Automatic Build System <autodist@mambasoft.it> 2.36.6-1mamba
- automatic version update by autodist

* Fri Jul 29 2022 Automatic Build System <autodist@mambasoft.it> 2.36.5-1mamba
- automatic version update by autodist

* Mon Jul 11 2022 Automatic Build System <autodist@mambasoft.it> 2.36.4-1mamba
- automatic version update by autodist

* Mon May 30 2022 Automatic Build System <autodist@mambasoft.it> 2.36.3-1mamba
- automatic version update by autodist

* Thu May 19 2022 Automatic Build System <autodist@mambasoft.it> 2.36.2-1mamba
- automatic version update by autodist

* Mon Apr 25 2022 Automatic Build System <autodist@mambasoft.it> 2.36.1-1mamba
- automatic version update by autodist

* Tue Mar 22 2022 Automatic Build System <autodist@mambasoft.it> 2.36.0-1mamba
- automatic version update by autodist

* Fri Feb 18 2022 Automatic Build System <autodist@mambasoft.it> 2.34.6-1mamba
- automatic version update by autodist

* Wed Feb 09 2022 Automatic Build System <autodist@mambasoft.it> 2.34.5-1mamba
- automatic version update by autodist

* Sun Jan 23 2022 Automatic Build System <autodist@mambasoft.it> 2.34.4-1mamba
- automatic version update by autodist

* Wed Dec 22 2021 Automatic Build System <autodist@mambasoft.it> 2.34.3-1mamba
- automatic version update by autodist

* Tue Nov 30 2021 Automatic Build System <autodist@mambasoft.it> 2.34.2-1mamba
- automatic version update by autodist

* Thu Nov 18 2021 Silvan Calarco <silvan.calarco@mambasoft.it> 2.34.1-2mamba
- rebuuilt with CMAKE_BUILD_TYPE=Release to get 4.0 apiver instead of 4.1

* Sun Oct 24 2021 Automatic Build System <autodist@mambasoft.it> 2.34.1-1mamba
- automatic version update by autodist

* Mon Mar 29 2021 Automatic Build System <autodist@mambasoft.it> 2.32.0-1mamba
- automatic version update by autodist

* Sun Mar 21 2021 Automatic Build System <autodist@mambasoft.it> 2.30.6-1mamba
- automatic version update by autodist

* Wed Feb 24 2021 Automatic Build System <autodist@mambasoft.it> 2.30.5-1mamba
- automatic version update by autodist

* Sun Jan 17 2021 Silvan Calarco <silvan.calarco@mambasoft.it> 2.30.4-1mamba
- update to 2.30.4

* Sat Nov 14 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 2.30.2-1mamba
- update to 2.30.2

* Sat Sep 26 2020 Automatic Build System <autodist@mambasoft.it> 2.30.1-1mamba
- automatic version update by autodist

* Thu Jul 30 2020 Automatic Build System <autodist@mambasoft.it> 2.28.4-1mamba
- automatic version update by autodist

* Fri Jul 10 2020 Automatic Build System <autodist@mambasoft.it> 2.28.3-1mamba
- automatic version update by autodist

* Mon May 04 2020 Automatic Build System <autodist@mambasoft.it> 2.28.2-1mamba
- automatic version update by autodist

* Fri Mar 27 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 2.28.0-2mamba
- x86 build fixed, restored gtk-doc, build MiniBrowser

* Fri Mar 13 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 2.28.0-1mamba
- update to 2.28.0

* Fri Dec 28 2018 Automatic Build System <autodist@mambasoft.it> 2.22.5-1mamba
- automatic version update by autodist

* Fri Sep 28 2018 Automatic Build System <autodist@mambasoft.it> 2.22.2-1mamba
- automatic version update by autodist

* Thu Sep 06 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 2.22.0-1mamba
- update to 2.22.0

* Mon Feb 12 2018 Automatic Build System <autodist@mambasoft.it> 2.18.6-1mamba
- automatic version update by autodist

* Mon Aug 14 2017 Automatic Build System <autodist@mambasoft.it> 2.16.6-1mamba
- automatic version update by autodist

* Sun Feb 05 2017 Automatic Build System <autodist@mambasoft.it> 2.14.3-1mamba
- automatic version update by autodist

* Sun Oct 16 2016 Automatic Build System <autodist@mambasoft.it> 2.14.1-1mamba
- automatic version update by autodist

* Fri Sep 09 2016 Automatic Build System <autodist@mambasoft.it> 2.12.5-1mamba
- automatic version update by autodist

* Thu Sep 01 2016 Automatic Build System <autodist@mambasoft.it> 2.12.4-1mamba
- automatic version update by autodist

* Sun Aug 21 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 2.12.3-1mamba
- update to 2.12.3

* Thu Mar 24 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 2.12.0-1mamba
- update to 2.12.0

* Wed Apr 01 2015 Automatic Build System <autodist@mambasoft.it> 2.8.0-1mamba
- automatic update by autodist

* Wed Dec 31 2014 Automatic Build System <autodist@mambasoft.it> 2.7.3-1mamba
- automatic update by autodist

* Sat Nov 29 2014 Automatic Build System <autodist@mambasoft.it> 2.7.2-1mamba
- automatic update by autodist

* Tue Jul 22 2014 Automatic Build System <autodist@mambasoft.it> 2.4.4-1mamba
- automatic update by autodist

* Wed Jun 18 2014 Silvan Calarco <silvan.calarco@mambasoft.it> 2.4.3-1mamba
- update to 2.4.3

* Thu Nov 14 2013 Silvan Calarco <silvan.calarco@mambasoft.it> 2.2.2-2mamba
- rebuilt because previous release was packaged with a buggy rpm release

* Wed Nov 13 2013 Silvan Calarco <silvan.calarco@mambasoft.it> 2.2.2-1mamba
- update to 2.2.2

* Sat Aug 31 2013 Automatic Build System <autodist@mambasoft.it> 2.1.90.1-1mamba
- automatic update by autodist

* Fri Aug 23 2013 Automatic Build System <autodist@mambasoft.it> 2.1.4-1mamba
- automatic update by autodist

* Sun Jul 21 2013 Automatic Build System <autodist@mambasoft.it> 2.1.3-1mamba
- automatic update by autodist

* Mon Jun 17 2013 Automatic Build System <autodist@mambasoft.it> 2.0.3-1mamba
- update to 2.0.3

* Mon Jun 17 2013 Automatic Build System <autodist@mambasoft.it> 2.1.1-1mamba
- automatic version update by autodist

* Sun Apr 14 2013 Silvan Calarco <silvan.calarco@mambasoft.it> 2.0.0-2mamba
- rebuilt with devhelp 3.8.0

* Tue Apr 02 2013 Automatic Build System <autodist@mambasoft.it> 2.0.0-1mamba
- automatic version update by autodist

* Fri Mar 22 2013 Automatic Build System <autodist@mambasoft.it> 1.11.92-1mamba
- automatic version update by autodist

* Wed Mar 13 2013 Automatic Build System <autodist@mambasoft.it> 1.11.91-1mamba
- automatic version update by autodist

* Sat Mar 02 2013 Automatic Build System <autodist@mambasoft.it> 1.11.90-1mamba
- automatic version update by autodist

* Thu Oct 04 2012 Automatic Build System <autodist@mambasoft.it> 1.10.0-1mamba
- update to 1.10.0

* Wed Aug 15 2012 Automatic Build System <autodist@mambasoft.it> 1.8.2-1mamba
- automatic version update by autodist

* Wed Jun 06 2012 Silvan Calarco <silvan.calarco@mambasoft.it> 1.8.1-2mamba
- build for gtk3; rename to libwebkit-gtk3 (libwebkit-gtk is the gtk 2.0 version)

* Sun May 13 2012 Silvan Calarco <silvan.calarco@mambasoft.it> 1.8.1-1mamba
- update to 1.8.1

* Fri Feb 25 2011 Silvan Calarco <silvan.calarco@mambasoft.it> 1.3.10-2mamba
- rebuilt in devel
- buildrequire libjpeg-devel instead of libjpeg-turbo-devel

* Wed Jan 26 2011 gil <puntogil@libero.it> 1.3.10-1mamba
- update to 1.3.10

* Mon Nov 29 2010 gil <puntogil@libero.it> 1.3.6-2mamba
- rebuilt devel

* Tue Nov 09 2010 gil <puntogil@libero.it> 1.3.6-1mamba
- update to 1.3.6

* Thu Oct 07 2010 gil <puntogil@libero.it> 1.3.4-1mamba
- update to 1.3.4

* Wed Oct 06 2010 gil <puntogil@libero.it> 1.2.5-1mamba
- update to 1.2.5

* Mon Sep 13 2010 gil <puntogil@libero.it> 1.2.4-1mamba
- update to 1.2.4

* Thu Jul 22 2010 gil <puntogil@libero.it> 1.2.3-1mamba
- update to 1.2.3

* Wed Jun 23 2010 gil <puntogil@libero.it> 1.2.1-1mamba
- update to 1.2.1

* Sat Apr 24 2010 gil <puntogil@libero.it> 1.2.0-2mamba
- edit spec file

* Tue Apr 20 2010 gil <puntogil@libero.it> 1.2.0-1mamba
- update to 1.2.0

* Sat Dec 26 2009 gil <puntogil@libero.it> 1.1.15.4-1mamba
- update to 1.1.15.4

* Thu Jul 02 2009 gil <puntogil@libero.it> 1.1.10-1mamba
- update to 1.1.10

* Thu Jun 11 2009 gil <puntogil@libero.it> 1.1.9-1mamba
- update to 1.1.9

* Fri May 29 2009 gil <puntogil@libero.it> 1.1.8-1mamba
- update to 1.1.8

* Sat May 16 2009 gil <puntogil@libero.it> 1.1.7-1mamba
- update to 1.1.7

* Thu May 07 2009 gil <puntogil@libero.it> 1.1.6-1mamba
- update to 1.1.6

* Sat Apr 18 2009 gil <puntogil@libero.it> 1.1.5-1mamba
- update to 1.1.5

* Sat Mar 28 2009 gil <puntogil@libero.it> 1.1.4-1mamba
- update to 1.1.4

* Mon Nov 17 2008 gil <puntogil@libero.it> 1.0.1-1mamba
- package created by autospec
